---
title: String.prototype.indexOf()
slug: Web/JavaScript/Reference/Global_Objects/String/indexOf
tags:
  - JavaScript
  - Method
  - Prototype
  - Reference
  - String
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>indexOf()</code></strong> method returns the index within the calling {{jsxref("String")}} object of the first occurrence of the specified value, starting the search at <code>fromIndex</code>. Returns <code>-1</code> if the value is not found.</span></p>

<div>{{EmbedInteractiveExample("pages/js/string-indexof.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div class="note"><strong>Note:</strong> For the Array method, see {{jsxref("Array.prototype.indexOf()")}}.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>str</var>.indexOf(<var>searchValue [</var>, <var>fromIndex]</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>searchValue</var></code></dt>
 <dd>
 <p>The string value to search for.</p>

 <p>If no string is explicitly provided, <a href="https://tc39.github.io/ecma262/#sec-tostring"><var>searchValue</var> will be coerced to "<code>undefined</code>"</a>, and this value will be searched for in <code><var>str</var></code>.</p>

 <p>So, for example: <code>'undefined'.indexOf()</code> will return <code>0</code>, as <code>undefined</code> is found at position <code>0</code> in the string <code>undefined</code>. <code>'undefine'.indexOf()</code> however will return <code>-1</code>, as <code>undefined</code> is not found in the string <code>undefine</code>.</p>
 </dd>
 <dt><var><code>fromIndex</code></var> {{optional_inline}}</dt>
 <dd>
 <p>An integer representing the index at which to start the search. Defaults to <code>0</code>.</p>

 <p>For <var><code>fromIndex</code></var> values lower than <code>0</code>, or greater than <code><var>str</var>.length</code>, the search starts at index <code>0</code> and <code><var>str</var>.length</code>, respectively.</p>

 <p>For example, <code>'hello world'.indexOf('o', -5)</code> will return <code>4</code>, as it starts at position <code>0</code>, and <code>o</code> is found at position <code>4</code>. On the other hand, <code>'hello world'.indexOf('o', 11)</code> (and with any <code>fromIndex</code> value greater than <code>11</code>) will return <code>-1</code>, as the search is started at position <code>11</code>, a position <em>after</em> the end of the string.</p>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The index of the first occurrence of <code><var>searchValue</var></code>, or <code><strong>-1</strong></code> if not found.</p>

<p>An empty string <code><var>searchValue</var></code> produces strange results. With no <code><var>fromIndex</var></code> value, or any <code><var>fromIndex</var></code> value lower than the string's <code>length</code>, the returned value is the same as the <code><var>fromIndex</var></code> value:</p>

<pre class="brush: js">'hello world'.indexOf('') // returns 0
'hello world'.indexOf('', 0) // returns 0
'hello world'.indexOf('', 3) // returns 3
'hello world'.indexOf('', 8) // returns 8</pre>

<p>However, with any <code><var>fromIndex</var></code> value equal to or greater than the string's <code>length</code>, the returned value <em>is</em> the string's <code>length</code>:</p>

<pre class="brush: js">'hello world'.indexOf('', 11) // returns 11
'hello world'.indexOf('', 13) // returns 11
'hello world'.indexOf('', 22) // returns 11</pre>

<p>In the former instance, JS seems to find an empty string just after the specified index value. In the latter instance, JS seems to be finding an empty string at the end of the searched string.</p>

<h2 id="Description">Description</h2>

<p>Characters in a string are indexed from left to right. The index of the first character is <code>0</code>, and the index of the last character of a string called <code><var>stringName</var></code> is <code><var>stringName</var>.length - 1</code>.</p>

<pre class="brush: js">'Blue Whale'.indexOf('Blue')      // returns  0
'Blue Whale'.indexOf('Blute')     // returns -1
'Blue Whale'.indexOf('Whale', 0)  // returns  5
'Blue Whale'.indexOf('Whale', 5)  // returns  5
'Blue Whale'.indexOf('Whale', 7)  // returns -1
'Blue Whale'.indexOf('')          // returns  0
'Blue Whale'.indexOf('', 9)       // returns  9
'Blue Whale'.indexOf('', 10)      // returns 10
'Blue Whale'.indexOf('', 11)      // returns 10
</pre>

<p>The <code>indexOf()</code> method is case sensitive. For example, the following expression returns <code>-1</code>:</p>

<pre class="brush: js">'Blue Whale'.indexOf('blue')  // returns -1
</pre>

<h3 id="Checking_occurrences">Checking occurrences</h3>

<p>Note that <code>0</code> doesn't evaluate to <code>true</code> and <code>-1</code> doesn't evaluate to <code>false</code>. Therefore, when checking if a specific string exists within another string, the correct way to check would be:</p>

<pre class="brush: js">'Blue Whale'.indexOf('Blue') !== -1  // true
'Blue Whale'.indexOf('Bloe') !== -1  // false
~('Blue Whale'.indexOf('Bloe')) // 0, which is falsy
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_indexOf">Using <code>indexOf()</code></h3>

<p>The following example uses <code>indexOf()</code> to locate values in the string <code>"Brave new world"</code>.</p>

<pre class="brush: js">const str = 'Brave new world'

console.log('Index of first w from start is ' + str.indexOf('w'))   // logs 8
console.log('Index of "new" from start is ' + str.indexOf('new'))   // logs 6
</pre>

<h3 id="indexOf_and_case-sensitivity"><code>indexOf()</code> and case-sensitivity</h3>

<p>The following example defines two string variables.</p>

<p>The variables contain the same string, except that the second string contains uppercase letters. The first {{domxref("console.log()")}} method displays <code>19</code>. But because the <code>indexOf()</code> method is case sensitive, the string "<code>cheddar</code>" is not found in <code>myCapString</code>, so the second <code>console.log()</code> method displays <code>-1</code>.</p>

<pre class="brush: js">const myString    = 'brie, pepper jack, cheddar'
const myCapString = 'Brie, Pepper Jack, Cheddar'

console.log('myString.indexOf("cheddar") is ' + myString.indexOf('cheddar'))
// logs 19
console.log('myCapString.indexOf("cheddar") is ' + myCapString.indexOf('cheddar'))
// logs -1
</pre>

<h3 id="Using_indexOf_to_count_occurrences_of_a_letter_in_a_string">Using <code>indexOf()</code> to count occurrences of a letter in a string</h3>

<p>The following example sets <code>count</code> to the number of occurrences of the letter <code>e</code> in the string <code>str</code>:</p>

<pre class="brush: js">const str = 'To be, or not to be, that is the question.'
let count = 0
let position = str.indexOf('e')

while (position !== -1) {
  count++
  position = str.indexOf('e', position + 1)
}

console.log(count)  // displays 4
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-string.prototype.indexof', 'String.prototype.indexOf')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.String.indexOf")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("String.prototype.charAt()")}}</li>
 <li>{{jsxref("String.prototype.lastIndexOf()")}}</li>
 <li>{{jsxref("String.prototype.includes()")}}</li>
 <li>{{jsxref("String.prototype.split()")}}</li>
 <li>{{jsxref("Array.prototype.indexOf()")}}</li>
</ul>
